/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Record.xs. Do not edit this file, edit Record.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/IO/Handle/Record.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <limits.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/resource.h>
#include <fcntl.h>

#ifndef PerlIO
#define PerlIO_fileno(f) fileno(f)
#endif

static int
fdtype(int fd) {
  struct stat buf;
  if( fstat(fd, &buf)<0 ) return -1;
  return (buf.st_mode & S_IFMT);
}

static int
socket_family(int fd) {
  union {
    struct sockaddr sa;
    char data[PATH_MAX+sizeof(uint8_t)+sizeof(sa_family_t)];
  } un;
  socklen_t len;

  len=sizeof(un);
  if( getsockname(fd, &un.sa, &len)<0 ) return -1;
  return un.sa.sa_family;
}

static int
socket_type(int fd) {
  int type;
  int len=sizeof(type);
  if(fdtype(fd)!=S_IFSOCK) return -1;
  if( getsockopt(fd, SOL_SOCKET, SO_TYPE, (void*)&type, (void*)&len)<0 )
    return -1;
  return type;
}

# define FDS_KEY "IO::Handle::Record::fds_to_send"
static int
smsg(SV* stream, SV* buffer, SV* length, int offset, int flags) {
  struct msghdr msg;
  struct cmsghdr* cmsgp;
  struct iovec  iov[1];
  STRLEN blen;
  char* bufp;
  int i, ret=-1;
  SV **svp, *sv;
  AV *fd_av;
  int fd_av_len, send_fd;
  IO* io;

  bufp=SvPV(buffer, blen);
  if( offset<0 ) {
    if( -offset>blen ) croak("Offset outside string");
    offset+=blen;
  } else if( offset>=blen && blen>0 ) croak("Offset outside string");
  bufp+=offset;
  blen-=offset;

  if( SvOK(length) ) {
    IV l=SvIV(length);
    if( l<0 ) croak("Negative length");
    if( l<blen ) blen=l;
  }

  Zero(&msg, 1, struct msghdr);
  Zero(iov,  1, struct iovec);

  iov[0].iov_base=bufp;
  iov[0].iov_len=blen;

  msg.msg_iov=iov;
  msg.msg_iovlen=1;

  SETERRNO(0,0);
  if( SvROK(stream) &&
      (sv=SvRV(stream)) &&
      SvTYPE(sv)==SVt_PVGV &&
      (io=GvIO(sv)) &&
      IoIFP(io) ) {
    send_fd=PerlIO_fileno(IoIFP(io));
    
    svp=hv_fetch(GvHV(sv), FDS_KEY, sizeof(FDS_KEY)-1, FALSE);
    if( svp && SvROK(*svp) &&
	(fd_av=(AV*)SvRV(*svp)) &&
	SvTYPE(fd_av)==SVt_PVAV &&
	(fd_av_len=av_len(fd_av)+1)>0 ) {
      /* warn("--> sending %d fds", fd_av_len); */
      msg.msg_controllen=CMSG_SPACE(fd_av_len*sizeof(int));
      Newxz(msg.msg_control, msg.msg_controllen, char);
      cmsgp=CMSG_FIRSTHDR(&msg);
      cmsgp->cmsg_len=CMSG_LEN(fd_av_len*sizeof(int));
      cmsgp->cmsg_level=SOL_SOCKET;
      cmsgp->cmsg_type=SCM_RIGHTS;
      for( i=0; i<fd_av_len; i++ ) {
	svp=av_fetch(fd_av, i, FALSE);
	if( SvIOK(*svp) ) {	/* file descriptor */
	  ((int*)CMSG_DATA(cmsgp))[i]=SvIV(*svp);
	} else if( SvROK(*svp) &&  /* file handle */
		   (sv=SvRV(*svp)) &&
		   SvTYPE(sv)==SVt_PVGV &&
		   (io=GvIO(sv)) &&
		   IoIFP(io) ) {
	  ((int*)CMSG_DATA(cmsgp))[i]=PerlIO_fileno(IoIFP(io));
	} else {
	  SETERRNO(EBADF, RMS_IFI);
	  goto ret;
	}
      }

      ret=sendmsg(send_fd, &msg, flags);

      if( ret>0 ) {		/* data sent ==> clear fds_to_send */
	/* warn("--> clearing fds_to_send"); */
	av_undef(fd_av);
      }
    } else {
      ret=sendmsg(send_fd, &msg, flags);
    }

    /* warn("--> sending data chunk: controllen=%d, ret=%d", msg.msg_controllen, ret); */
  } else {
    SETERRNO(EBADF, RMS_IFI);
  }

 ret:
  if( msg.msg_control ) Safefree(msg.msg_control);
  return ret;
}

static SV*
call_open_fd( int fd ) {
  int n, socktype;
  SV *ret=NULL;
  dSP;

  ENTER;
  SAVETMPS;

  PUSHMARK(sp);
  XPUSHs(sv_2mortal(newSViv(fd)));
  XPUSHs(sv_2mortal(newSViv(fcntl(fd, F_GETFL, 0))));
  if( (socktype=socket_type(fd))>=0 )
    XPUSHs(sv_2mortal(newSViv(socktype)));
  PUTBACK;

  n=call_pv("open_fd", G_SCALAR | G_EVAL);

  SPAGAIN;

  if( n==1 ) {
    ret=POPs;
    (void)SvREFCNT_inc(ret);
  }

  PUTBACK;
  FREETMPS;
  LEAVE;

  return ret;
}

# define RCV_KEY "IO::Handle::Record::_received_fds"
static int
rmsg(SV* stream, SV* buffer, int length, int offset, int flags) {
  struct msghdr msg;
  struct cmsghdr* cmsgp;
  struct iovec  iov[1];
  struct rlimit rlim;
  STRLEN blen;
  int i, ret=-1, nfds, *fdp;
  SV *sv, **svp;
  AV *fd_av;
  IO* io;

  if( !SvOK(buffer) ) sv_setpvn(buffer, "", 0);
  if( length<0 ) croak("Negative length");

  SvPV_force(buffer, blen);

  if( offset<0 ) {
    if( -offset>(int)blen ) croak("Offset outside string");
    offset+=blen;
  }

  SvGROW(buffer, length+1);

  /* pad with \0 if offset > size of the buffer */
  if( offset>SvCUR(buffer) ) Zero(SvEND(buffer), offset-SvCUR(buffer), char);

  Zero(&msg, 1, struct msghdr);
  Zero(iov,  1, struct iovec);

  iov[0].iov_base=SvPVX(buffer)+offset;
  iov[0].iov_len=length;

  msg.msg_iov=iov;
  msg.msg_iovlen=1;

  if( getrlimit( RLIMIT_NOFILE, &rlim )<0 ) {
    rlim.rlim_cur=1024;
  }

  msg.msg_controllen=CMSG_SPACE(rlim.rlim_cur*sizeof(int));
  Newxz(msg.msg_control, msg.msg_controllen, char);

  SETERRNO(0,0);
  if( SvROK(stream) &&
      (sv=SvRV(stream)) &&
      SvTYPE(sv)==SVt_PVGV &&
      (io=GvIO(sv)) &&
      IoIFP(io) ) {
    if( (ret=recvmsg(PerlIO_fileno(IoIFP(io)), &msg, flags))<0 ) goto ret;

    SvCUR_set(buffer, ret+offset);
    *SvEND(buffer)='\0';
    SvPOK_only(buffer);

    if( (cmsgp=CMSG_FIRSTHDR(&msg))!=NULL &&
	cmsgp->cmsg_len>0 &&
	cmsgp->cmsg_level==SOL_SOCKET &&
	cmsgp->cmsg_type==SCM_RIGHTS ) {
      fdp=(int*)CMSG_DATA(cmsgp);
      nfds=(cmsgp->cmsg_len-
	    ((char*)fdp-(char*)cmsgp))/sizeof(int);
      /* warn("==> expecting %d fds -- got %d bytes, %d fds", rlim.rlim_cur, ret, nfds); */
      if( nfds>0 ) {
	/* sv is the typeglob of the filehandle here */
	svp=hv_fetch(GvHV(sv), RCV_KEY, sizeof(RCV_KEY)-1, FALSE);
	if( !(svp && SvROK(*svp) &&
	      (fd_av=(AV*)SvRV(*svp)) &&
	      SvTYPE(fd_av)==SVt_PVAV) ) {
	  /*
	   * ${*$I}{RCV_KEY}=[]
	   *   unless exists ${*$I}{RCV_KEY} and
	   *          ref(${*$I}{RCV_KEY}) eq 'ARRAY'
	   */
	  (void)hv_store(GvHV(sv), RCV_KEY, sizeof(RCV_KEY)-1,
			 newRV_inc((SV*)(fd_av=newAV())), 0);
	}
	av_extend(fd_av, av_len(fd_av)+1+nfds);
	    
	for( i=0; i<nfds; i++ ) {
	  sv=call_open_fd(fdp[i]);
	  if( sv ) av_push(fd_av, sv);
	}
      }
/*     } else { */
/*       warn("==> expecting %d fds -- got %d bytes, no CMSG", rlim.rlim_cur, ret); */
    }
  } else {
    SETERRNO(EBADF, RMS_IFI);
  }

 ret:
  if( msg.msg_control ) Safefree(msg.msg_control);
  return ret;
}

#line 278 "lib/IO/Handle/Record.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 422 "lib/IO/Handle/Record.c"

XS_EUPXS(XS_IO__Handle__Record_peercred); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Handle__Record_peercred)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "s");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	PerlIO*	s = IoIFP(sv_2io(ST(0)))
;
#line 275 "lib/IO/Handle/Record.xs"
{
# ifdef SO_PEERCRED
  struct ucred uc;
  socklen_t uc_len=sizeof(uc);

  if( !getsockopt(PerlIO_fileno(s), SOL_SOCKET, SO_PEERCRED, &uc, &uc_len) ) {
    EXTEND(SP, 3);
    PUSHs(sv_2mortal(newSViv(uc.pid)));
    PUSHs(sv_2mortal(newSViv(uc.uid)));
    PUSHs(sv_2mortal(newSViv(uc.gid)));
  }
# else
  SETERRNO(EOPNOTSUPP, RMS_IFI);
# endif
}
#line 451 "lib/IO/Handle/Record.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__Handle__Record_issock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Handle__Record_issock)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "s");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	PerlIO*	s = IoIFP(sv_2io(ST(0)))
;
#line 296 "lib/IO/Handle/Record.xs"
{
  if( fdtype(PerlIO_fileno(s))==S_IFSOCK ) {
    XSRETURN_YES;
  } else {
    XSRETURN_UNDEF;
  }
}
#line 477 "lib/IO/Handle/Record.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__Handle__Record_typeof); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Handle__Record_typeof)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	char *	RETVAL;
	dXSTARG;
#line 309 "lib/IO/Handle/Record.xs"
{
  switch(fdtype(fd)) {
  case S_IFSOCK:
    switch(socket_family(fd)) {
    case AF_UNIX:
      RETVAL=("IO::Socket::UNIX");
      break;
    case AF_INET:
      RETVAL=("IO::Socket::INET");
      break;
    case AF_INET6:
      RETVAL=("IO::Socket::INET6");
      break;
    default:
      RETVAL=("IO::Handle");
      break;
    }
    break;
  case S_IFREG:
    RETVAL=("IO::File");
    break;
  case S_IFDIR:
    RETVAL=("IO::Dir");
    break;
  case S_IFIFO:
    RETVAL=("IO::Pipe");
    break;
  default:
    RETVAL=("IO::Handle");
    break;
  }
}
#line 528 "lib/IO/Handle/Record.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Handle__Record_socket_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Handle__Record_socket_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "s");
    {
	int	s = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 350 "lib/IO/Handle/Record.xs"
    RETVAL=socket_type(s);

#line 549 "lib/IO/Handle/Record.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Handle__Record_socket_family); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Handle__Record_socket_family)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "s");
    {
	int	s = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 361 "lib/IO/Handle/Record.xs"
    RETVAL=socket_family(s);

#line 570 "lib/IO/Handle/Record.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Handle__Record_sendmsg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Handle__Record_sendmsg)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 5)
       croak_xs_usage(cv,  "s, buf, len = &PL_sv_undef, offset = 0, flags = 0");
    {
	SV*	s = ST(0)
;
	SV*	buf = ST(1)
;
	SV*	len;
	int	offset;
	int	flags;
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    len = &PL_sv_undef;
	else {
	    len = ST(2)
;
	}

	if (items < 4)
	    offset = 0;
	else {
	    offset = (int)SvIV(ST(3))
;
	}

	if (items < 5)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(4))
;
	}
#line 376 "lib/IO/Handle/Record.xs"
    if ((RETVAL = smsg(s, buf, len, offset, flags)) < 0 ) 
      XSRETURN_UNDEF;

#line 618 "lib/IO/Handle/Record.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Handle__Record_recvmsg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Handle__Record_recvmsg)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 5)
       croak_xs_usage(cv,  "s, buf, len, offset = 0, flags = 0");
    {
	SV*	s = ST(0)
;
	SV*	buf = ST(1)
;
	int	len = (int)SvIV(ST(2))
;
	int	offset;
	int	flags;
	int	RETVAL;
	dXSTARG;

	if (items < 4)
	    offset = 0;
	else {
	    offset = (int)SvIV(ST(3))
;
	}

	if (items < 5)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(4))
;
	}
#line 392 "lib/IO/Handle/Record.xs"
    if ((RETVAL = rmsg(s, buf, len, offset, flags)) < 0 ) 
      XSRETURN_UNDEF;

#line 660 "lib/IO/Handle/Record.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_IO__Handle__Record); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_IO__Handle__Record)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("IO::Handle::Record::peercred", XS_IO__Handle__Record_peercred, file, "$");
        (void)newXSproto_portable("IO::Handle::Record::issock", XS_IO__Handle__Record_issock, file, "$");
        (void)newXSproto_portable("IO::Handle::Record::typeof", XS_IO__Handle__Record_typeof, file, "$");
        (void)newXSproto_portable("IO::Handle::Record::socket_type", XS_IO__Handle__Record_socket_type, file, "$");
        (void)newXSproto_portable("IO::Handle::Record::socket_family", XS_IO__Handle__Record_socket_family, file, "$");
        (void)newXSproto_portable("IO::Handle::Record::sendmsg", XS_IO__Handle__Record_sendmsg, file, "$$;$$$");
        (void)newXSproto_portable("IO::Handle::Record::recvmsg", XS_IO__Handle__Record_recvmsg, file, "$$$;$$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

